Bug 1020186 - xfce4-terminal ignores SIGQUIT
xfce4-terminal ignores SIGQUIT
Status: CLOSED EOL
Product: Fedora
Classification: Fedora
Component: vte (Show other bugs)
20
Unspecified Unspecified
unspecified Severity unspecified
: ---
: ---
Assigned To: Kevin Fenzi
Fedora Extras Quality Assurance
:
Depends On:
Blocks:
  Show dependency treegraph
 
Reported: 2013-10-17 04:44 EDT by Jan "Yenya" Kasprzak
Modified: 2015-06-29 20:43 EDT (History)
2 users (show)

See Also:
Fixed In Version:
Doc Type: Bug Fix
Doc Text:
Story Points: ---
Clone Of:
Environment:
Last Closed: 2015-06-29 20:43:52 EDT
Type: Bug
Regression: ---
Mount Type: ---
Documentation: ---
CRM:
Verified Versions:
Category: ---
oVirt Team: ---
RHEL 7.3 requirements from Atomic Host:
Cloudforms Team: ---


Attachments (Terms of Use)


External Trackers
Tracker ID Priority Status Summary Last Updated
Debian BTS 726309 None None None Never

  None (edit)
Description Jan "Yenya" Kasprzak 2013-10-17 04:44:45 EDT
Description of problem:
It is not possible to send SIGQUIT to a process inside the xfce4-terminal. The problem is caused by xfce4-terminal ignoring SIGQUIT (setting it to SIG_IGN). Bash ignores SIGQUIT by default (see the manpage), but it restores SIGQUIT to the previous value for its children. But when the previous value (inherited from xfce4-terminal) was SIG_IGN, it remains to be set to SIG_IGN even for the children.

Version-Release number of selected component (if applicable):
vte-0.28.2-9.fc19.x86_64
xfce4-terminal-0.6.2-1.fc19.x86_64
bash-4.2.45-1.fc19.x86_64

How reproducible:
100 %

Steps to Reproduce:
1. open xfce4-terminal
2. run "/usr/bin/sleep 100 &" inside it.
3. try to interrupt it with SIGQUIT: "kill -QUIT %%"

Expected results:
the sleep process should be killed, optionally with a coredump

Actual results:
the sleep process remains alive until the 100 seconds timeout

Additional info:
1. from the same xfce4-terminal, do "ssh localhost", log in, and re-run the above (sleep & kill -QUIT). It works as expected.

2. using "ps xs" it can be seen that xfce4-terminal, bash and sleep have SIGQUIT set to SIG_IGN (look for the 0x0000000000000004 bit in the IGNORED column). Other xfce4 processes (session, window manager, etc.) do not have SIGQUIT ignored. Also, the sleep command started from the "ssh localhost" session does not have SIGQUIT ignored.

The following Stackoverflow thread suggests that the similar problem has been observed also in gnome-terminal, so I am assigning this to their greatest common denominator, libvte:

http://stackoverflow.com/questions/6381353/how-do-i-trap-sigquit-properly-in-a-bash-script/19420898#19420898

This is probably also related to Debian bug #726309.
Comment 1 Kevin Fenzi 2013-10-17 18:17:21 EDT
Does this happen in modern gnome-terminal? 

xfce4-terminal uses vte, but with gnome3, gnome-terminal now uses vte3. 

vte is an old version without much development going on. 
Perhaps we should move this to vte3 and see what they say there, then if the fix could be backported to vte we could do so?
Comment 2 Jan "Yenya" Kasprzak 2013-10-18 04:56:53 EDT
Gnome-terminal works for me - gnome-terminal-server itself runs without SIGQUIT blocked.

vte3-0.34.6-1.fc19.x86_64
gnome-terminal-3.8.4-1.fc19.x86_64

So this is probably a bug in vte, not vte3.
Comment 3 Kevin Fenzi 2013-10-27 13:51:36 EDT
ok. I guess I'll look around through vte3 commits and see if there's something we could backport. 

If you or anyone else wants to point to a likely commit, please do. ;)
Comment 4 Fedora End Of Life 2015-01-09 17:20:34 EST
This message is a notice that Fedora 19 is now at end of life. Fedora 
has stopped maintaining and issuing updates for Fedora 19. It is 
Fedora's policy to close all bug reports from releases that are no 
longer maintained. Approximately 4 (four) weeks from now this bug will
be closed as EOL if it remains open with a Fedora 'version' of '19'.

Package Maintainer: If you wish for this bug to remain open because you
plan to fix it in a currently maintained version, simply change the 'version' 
to a later Fedora version.

Thank you for reporting this issue and we are sorry that we were not 
able to fix it before Fedora 19 is end of life. If you would still like 
to see this bug fixed and are able to reproduce it against a later version 
of Fedora, you are encouraged  change the 'version' to a later Fedora 
version prior this bug is closed as described in the policy above.

Although we aim to fix as many bugs as possible during every release's 
lifetime, sometimes those efforts are overtaken by events. Often a 
more recent Fedora release includes newer upstream software that fixes 
bugs or makes them obsolete.
Comment 5 Jan "Yenya" Kasprzak 2015-01-13 11:43:39 EST
This is also present in F20.

xfce4-terminal-0.6.3-1.fc20.x86_64
vte-0.28.2-13.fc20.x86_64
Comment 6 Egmont Koblinger 2015-04-27 10:05:53 EDT
Upstream: https://bugzilla.gnome.org/show_bug.cgi?id=748520
Comment 7 Fedora End Of Life 2015-05-29 05:35:15 EDT
This message is a reminder that Fedora 20 is nearing its end of life.
Approximately 4 (four) weeks from now Fedora will stop maintaining
and issuing updates for Fedora 20. It is Fedora's policy to close all
bug reports from releases that are no longer maintained. At that time
this bug will be closed as EOL if it remains open with a Fedora  'version'
of '20'.

Package Maintainer: If you wish for this bug to remain open because you
plan to fix it in a currently maintained version, simply change the 'version' 
to a later Fedora version.

Thank you for reporting this issue and we are sorry that we were not 
able to fix it before Fedora 20 is end of life. If you would still like 
to see this bug fixed and are able to reproduce it against a later version 
of Fedora, you are encouraged  change the 'version' to a later Fedora 
version prior this bug is closed as described in the policy above.

Although we aim to fix as many bugs as possible during every release's 
lifetime, sometimes those efforts are overtaken by events. Often a 
more recent Fedora release includes newer upstream software that fixes 
bugs or makes them obsolete.
Comment 8 Fedora End Of Life 2015-06-29 20:43:52 EDT
Fedora 20 changed to end-of-life (EOL) status on 2015-06-23. Fedora 20 is
no longer maintained, which means that it will not receive any further
security or bug fix updates. As a result we are closing this bug.

If you can reproduce this bug against a currently maintained version of
Fedora please feel free to reopen this bug against that version. If you
are unable to reopen this bug, please file a new report against the
current release. If you experience problems, please add a comment to this
bug.

Thank you for reporting this bug and we are sorry it could not be fixed.

Note You need to log in before you can comment on or make changes to this bug.